// Code generated by swaggo/swag. DO NOT EDIT
package docs

import "github.com/swaggo/swag"

const docTemplate = `{
    "schemes": {{ marshal .Schemes }},
    "swagger": "2.0",
    "info": {
        "description": "{{escape .Description}}",
        "title": "{{.Title}}",
        "contact": {},
        "version": "{{.Version}}"
    },
    "host": "{{.Host}}",
    "basePath": "{{.BasePath}}",
    "paths": {
        "/": {
            "get": {
                "description": "Give server index page response",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "common"
                ],
                "summary": "Index page",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/admin/user": {
            "get": {
                "description": "Get all users from database",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "admin"
                ],
                "summary": "Get All User",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "post": {
                "description": "Add a user to database",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "admin"
                ],
                "summary": "Add User",
                "parameters": [
                    {
                        "description": "Admin Add User Payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/admin.AdminAddUserPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/admin/user/{email}": {
            "get": {
                "description": "Get a user from database",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "admin"
                ],
                "summary": "Get User By Email",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "delete": {
                "description": "Delete a user from database",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "admin"
                ],
                "summary": "Delete User By Id",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "patch": {
                "description": "Update a user from database",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "admin"
                ],
                "summary": "Update User By Id",
                "parameters": [
                    {
                        "description": "Admin Update User Payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/admin.AdminUpdateUserPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/auth/login": {
            "post": {
                "description": "Login and generate new pair of token",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "auth"
                ],
                "summary": "Login",
                "parameters": [
                    {
                        "description": "Login payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/login.LoginRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Login Success",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/login.LoginResponsePayload"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "Bad Input",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "type": "string"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "403": {
                        "description": "Login Credential Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "415": {
                        "description": "Not a json request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Invalid JSON input",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Unknown Internal Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/auth/refresh": {
            "post": {
                "description": "Generate new access token",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "auth"
                ],
                "summary": "Refresh Token",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Refresh token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/refresh.RefreshResponsePayload"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/auth/register": {
            "post": {
                "description": "Generate New Account as Member",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "auth"
                ],
                "summary": "Register New Account",
                "parameters": [
                    {
                        "description": "Register Payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/register.RegisterRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/auth/verify": {
            "post": {
                "description": "Do Email Verification to user",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "auth"
                ],
                "summary": "Do Email Verification",
                "parameters": [
                    {
                        "description": "Register Payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/verification.VerificationRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/auth/verify/resend": {
            "post": {
                "description": "Send Email Verification to user",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "auth"
                ],
                "summary": "Send Email Verification",
                "parameters": [
                    {
                        "description": "Register Payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/verification.VerificationSendRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course": {
            "get": {
                "description": "Retrieve a list of all available courses.",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get all courses",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "put": {
                "description": "Add a new course with the given details",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Add a new course",
                "parameters": [
                    {
                        "type": "string",
                        "description": "AddCourseToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Add Course payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/course.AddCourseRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/faculty": {
            "get": {
                "description": "Retrieves a list of all faculties",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get all faculties",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "put": {
                "description": "Adds a new faculty with the given details",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Add a new faculty",
                "parameters": [
                    {
                        "type": "string",
                        "description": "AddFacultyToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Add Faculty payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/faculty.AddFacultyRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/faculty/courses/{id}": {
            "get": {
                "description": "Retrieve all courses that belong to the faculty with the given ID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get all courses by faculty ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Faculty ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/faculty/majors/{id}": {
            "get": {
                "description": "Returns a list of majors associated with the given faculty ID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get majors by faculty ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Faculty ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/faculty/{id}": {
            "get": {
                "description": "Retrieve faculty data by UUID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get faculty by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Faculty ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "patch": {
                "description": "Update a faculty with the given ID",
                "tags": [
                    "course"
                ],
                "summary": "Update a faculty",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Faculty ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "Update Faculty Payload",
                        "name": "payload",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/faculty.UpdateFacultyRequestPayload"
                        }
                    },
                    {
                        "type": "string",
                        "description": "UpdateFacultyToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/major": {
            "get": {
                "description": "Get a list of all majors",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get all majors",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "put": {
                "description": "Add a new major to a faculty",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Add Major",
                "parameters": [
                    {
                        "type": "string",
                        "description": "AddMajorToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Add Major payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/major.AddMajorRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/major/courses/{id}": {
            "get": {
                "description": "Retrieve all courses related to a major",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get courses by major",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Major ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/major/{id}": {
            "get": {
                "description": "Get a major by ID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get a major by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Major ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "put": {
                "description": "Update a major with the given ID",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Update a major",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Major ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "UpdateMajorToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Update Major payload",
                        "name": "payload",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/major.UpdateMajorRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/{id}": {
            "get": {
                "description": "Retrieve a course by ID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get a course by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "ID of the course to retrieve",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "delete": {
                "description": "Delete a course with the specified ID",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Delete course by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Course ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "DeleteCourseToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "patch": {
                "description": "Update an existing course.",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Update Course",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "Course ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "UpdateCourseToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Update Course Payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/course.UpdateCourseRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/{id}/material": {
            "post": {
                "description": "Add new material",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "content"
                ],
                "summary": "Add Material",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Access token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Material Request",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/material.CreateMaterialRequest"
                        }
                    },
                    {
                        "type": "string",
                        "example": "IF3230",
                        "description": "Course id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/material.CreateMaterialResponse"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/course/{id}/materials": {
            "get": {
                "description": "Get materials",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "content"
                ],
                "summary": "Get materials",
                "parameters": [
                    {
                        "type": "string",
                        "example": "IF3270",
                        "description": "Course id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/material.Material"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            }
        },
        "/course/{id}/quiz": {
            "get": {
                "description": "Get all cours",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "course"
                ],
                "summary": "Get Course quiz",
                "parameters": [
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Course id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "type": "array",
                                            "items": {
                                                "$ref": "#/definitions/quiz.Quiz"
                                            }
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            }
        },
        "/lesson": {
            "put": {
                "description": "Add a new lesson with the given details",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Add a new lesson",
                "parameters": [
                    {
                        "type": "string",
                        "description": "AddLessonToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Add Lesson payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/lesson.AddLessonRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/lesson/course/{id}": {
            "get": {
                "description": "Retrieve lesson data by course ID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Get lesson by course ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Course ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid ID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/lesson/material": {
            "put": {
                "description": "Add a new lesson material with the given details",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Add a new lesson material",
                "parameters": [
                    {
                        "type": "string",
                        "description": "AddLessonMaterialsToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Add Lesson Material payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/materials.AddLessonMaterialsRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/lesson/material/lesson/{id}": {
            "get": {
                "description": "Retrieve lesson materials data by lesson ID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Get lesson materials by lesson ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Lesson ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/lesson/material/{id}": {
            "get": {
                "description": "Retrieve lesson data by UUID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Get lesson by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Lesson ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "delete": {
                "description": "Delete a lesson material with the specified ID",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Delete lesson material by id",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Lesson Material ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "DeleteLessonMaterialToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/lesson/{id}": {
            "get": {
                "description": "Retrieve lesson data by UUID",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Get lesson by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Lesson ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Invalid UUID provided in request path",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "delete": {
                "description": "Delete a lesson with the specified ID",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "lesson"
                ],
                "summary": "Delete lesson by ID",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Lesson ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "DeleteLessonToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "patch": {
                "description": "Update a lesson material with the given ID",
                "tags": [
                    "lesson"
                ],
                "summary": "Update a lesson material",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Lesson Material ID (UUID)",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "Update Lesson Materials Payload",
                        "name": "payload",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/materials.UpdateLessonMaterialsRequestPayload"
                        }
                    },
                    {
                        "type": "string",
                        "description": "UpdateLessonMaterialsToken",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "403": {
                        "description": "Forbidden",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "422": {
                        "description": "Unprocessable Entity",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/material/{id}": {
            "get": {
                "description": "Get material detail",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "content"
                ],
                "summary": "Get material detail",
                "parameters": [
                    {
                        "type": "string",
                        "example": "IF3270",
                        "description": "Material id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/material.Material"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            },
            "post": {
                "description": "Add content of material",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "content"
                ],
                "summary": "Add Content",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Access token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Add content request",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/material.NewContentRequest"
                        }
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Material id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/material.NewContentResponse"
                                        }
                                    }
                                }
                            ]
                        }
                    },
                    "400": {
                        "description": "Bad Request",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    },
                    "401": {
                        "description": "Unauthorized",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "delete": {
                "description": "Delete material",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "content"
                ],
                "summary": "Delete material",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Access token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Material id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/material/{id}/content/{content-id}": {
            "delete": {
                "description": "Delete content of material",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "content"
                ],
                "summary": "Delete Content",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Access token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Material id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Content id",
                        "name": "content-id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/quiz": {
            "put": {
                "description": "New Quiz",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "New Quiz",
                "parameters": [
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "Add Quiz payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/quiz.AddQuizRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/quiz/{id}": {
            "get": {
                "description": "Get Quiz Detail",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "Get Quiz Detail",
                "parameters": [
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/quiz.Quiz"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            },
            "delete": {
                "description": "Delete Quiz",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "Delete Quiz",
                "parameters": [
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            },
            "patch": {
                "description": "Update Quiz",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "Update Quiz",
                "parameters": [
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "Update Quiz payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/quiz.UpdateQuizRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/quiz/{id}/finish": {
            "post": {
                "description": "Finish quiz session and get the score",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "Finish Quiz",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Authenticate User (any role)",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "Quiz Finish payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/quiz.FinishQuizPayload"
                        }
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/quiz.QuizDetail"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            }
        },
        "/quiz/{id}/solution": {
            "get": {
                "description": "Take a quiz",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "Get Quiz Solution",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Authenticate User (any role)",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/quiz.QuizDetail"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            }
        },
        "/quiz/{id}/take": {
            "post": {
                "description": "Take a quiz",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "quiz"
                ],
                "summary": "Take Quiz",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Authenticate User (any role)",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "type": "string",
                        "format": "uuid",
                        "description": "Quiz id",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "allOf": [
                                {
                                    "$ref": "#/definitions/web.BaseResponse"
                                },
                                {
                                    "type": "object",
                                    "properties": {
                                        "data": {
                                            "$ref": "#/definitions/quiz.QuizDetail"
                                        }
                                    }
                                }
                            ]
                        }
                    }
                }
            }
        },
        "/reset/confirm": {
            "put": {
                "description": "Do confirmation to reset password",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "reset"
                ],
                "summary": "Confirm Reset Password",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Email validation token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    },
                    {
                        "description": "payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/confirm.ConfirmRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Login Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/reset/request": {
            "post": {
                "description": "Send Reset password token to email",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "reset"
                ],
                "summary": "Request Reset Password Token",
                "parameters": [
                    {
                        "description": "payload",
                        "name": "data",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/request.RequestRequestPayload"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Login Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        },
        "/reset/validate": {
            "get": {
                "description": "Send Reset password token to email",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "reset"
                ],
                "summary": "Request Reset Password Token",
                "parameters": [
                    {
                        "type": "string",
                        "description": "Email validation token",
                        "name": "Authorization",
                        "in": "header",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "Login Success",
                        "schema": {
                            "$ref": "#/definitions/web.BaseResponse"
                        }
                    }
                }
            }
        }
    },
    "definitions": {
        "admin.AdminAddUserPayload": {
            "type": "object",
            "required": [
                "email",
                "name",
                "role"
            ],
            "properties": {
                "email": {
                    "description": "User Email",
                    "type": "string",
                    "example": "someone@example.com"
                },
                "name": {
                    "description": "User name",
                    "type": "string",
                    "example": "someone"
                },
                "role": {
                    "description": "User Role",
                    "type": "string",
                    "example": "admin"
                }
            }
        },
        "admin.AdminUpdateUserPayload": {
            "type": "object",
            "required": [
                "email",
                "name",
                "role"
            ],
            "properties": {
                "email": {
                    "description": "User Email",
                    "type": "string",
                    "example": "someone@example.com"
                },
                "name": {
                    "description": "User name",
                    "type": "string",
                    "example": "someone"
                },
                "role": {
                    "description": "User Role",
                    "type": "string",
                    "example": "admin"
                }
            }
        },
        "confirm.ConfirmRequestPayload": {
            "description": "Information that should be available when you confirm a password reset",
            "type": "object",
            "required": [
                "password",
                "password_validation"
            ],
            "properties": {
                "confirmToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "password": {
                    "description": "User Password",
                    "type": "string",
                    "example": "secret"
                },
                "password_validation": {
                    "description": "User Password Validation, must be same as user",
                    "type": "string",
                    "example": "secret"
                }
            }
        },
        "course.AddCourseRequestPayload": {
            "description": "Information that should be available when you add a course",
            "type": "object",
            "required": [
                "email",
                "id",
                "name"
            ],
            "properties": {
                "abbreviation": {
                    "description": "Course Name Abbreviation",
                    "type": "string"
                },
                "addCourseToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "description": {
                    "description": "Course Description (Can be left empty)",
                    "type": "string"
                },
                "email": {
                    "description": "Contributor Email",
                    "type": "string",
                    "example": "someone@example.com"
                },
                "id": {
                    "description": "Course ID",
                    "type": "string"
                },
                "lecturer": {
                    "description": "Course Lecturer Name",
                    "type": "string"
                },
                "majabbr": {
                    "description": "Course Major Abbreviation",
                    "type": "string"
                },
                "major_id": {
                    "description": "Major Id, will be set by the server",
                    "type": "string"
                },
                "name": {
                    "description": "Course Name",
                    "type": "string"
                }
            }
        },
        "course.UpdateCourseRequestPayload": {
            "description": "Information that should be available when you add a course",
            "type": "object",
            "required": [
                "email",
                "name"
            ],
            "properties": {
                "abbreviation": {
                    "description": "Course Name Abbreviation",
                    "type": "string"
                },
                "description": {
                    "description": "Course Description (Can be left empty)",
                    "type": "string"
                },
                "email": {
                    "description": "Contributor Email",
                    "type": "string",
                    "example": "someone@example.com"
                },
                "lecturer": {
                    "description": "Course Lecturer Name",
                    "type": "string"
                },
                "majabbr": {
                    "description": "Course Major Abbreviation",
                    "type": "string"
                },
                "major_id": {
                    "description": "Major Id, will be set by the server",
                    "type": "string"
                },
                "name": {
                    "description": "Course Name",
                    "type": "string"
                },
                "updateCourseToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                }
            }
        },
        "faculty.AddFacultyRequestPayload": {
            "description": "Information that should be available when you add a faculty",
            "type": "object",
            "required": [
                "abbreviation",
                "name"
            ],
            "properties": {
                "abbreviation": {
                    "description": "Faculty Name Abbreviation",
                    "type": "string"
                },
                "faculty_token": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "name": {
                    "description": "Faculty Name",
                    "type": "string"
                }
            }
        },
        "faculty.UpdateFacultyRequestPayload": {
            "description": "Information that should be available when you update a faculty",
            "type": "object",
            "required": [
                "abbreviation",
                "name"
            ],
            "properties": {
                "abbreviation": {
                    "description": "Faculty Name Abbreviation",
                    "type": "string"
                },
                "name": {
                    "description": "Faculty Name",
                    "type": "string"
                },
                "updateFacultyToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                }
            }
        },
        "lesson.AddLessonRequestPayload": {
            "description": "Information that should be available when you add a lesson",
            "type": "object",
            "required": [
                "course_id",
                "name",
                "order"
            ],
            "properties": {
                "addLessonToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "course_id": {
                    "description": "Course ID",
                    "type": "string"
                },
                "description": {
                    "description": "Lesson Description (Can be left empty)",
                    "type": "string"
                },
                "name": {
                    "description": "Lesson Name",
                    "type": "string"
                },
                "order": {
                    "description": "Lesson Order",
                    "type": "integer"
                }
            }
        },
        "lesson.UpdateLessonRequestPayload": {
            "description": "Information that should be available when you update a lesson",
            "type": "object",
            "required": [
                "course_id",
                "name",
                "order"
            ],
            "properties": {
                "course_id": {
                    "description": "Course ID",
                    "type": "string"
                },
                "description": {
                    "description": "Lesson Description (Can be left empty)",
                    "type": "string"
                },
                "name": {
                    "description": "Lesson Name",
                    "type": "string"
                },
                "order": {
                    "description": "Lesson Order",
                    "type": "integer"
                },
                "updateLessonToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                }
            }
        },
        "login.LoginRequestPayload": {
            "description": "Information that should be available when do a login process",
            "type": "object",
            "required": [
                "email",
                "password"
            ],
            "properties": {
                "email": {
                    "description": "User Email",
                    "type": "string",
                    "example": "someone@example.com"
                },
                "password": {
                    "description": "User Password",
                    "type": "string",
                    "example": "secret"
                }
            }
        },
        "login.LoginResponsePayload": {
            "description": "Login response when process success",
            "type": "object",
            "properties": {
                "access_token": {
                    "description": "Token that used to access the resources",
                    "type": "string"
                },
                "refresh_token": {
                    "description": "Token that used to generate new access token",
                    "type": "string"
                }
            }
        },
        "major.AddMajorRequestPayload": {
            "description": "Information that should be available when you add a major",
            "type": "object",
            "required": [
                "abbreviation",
                "name"
            ],
            "properties": {
                "abbreviation": {
                    "description": "Major Name Abbreviation",
                    "type": "string"
                },
                "facabbr": {
                    "description": "Major Faculty Abbreviation",
                    "type": "string"
                },
                "faculty_id": {
                    "description": "Faculty Id, will be set by the server",
                    "type": "string"
                },
                "major_token": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "name": {
                    "description": "Major Name",
                    "type": "string"
                }
            }
        },
        "major.UpdateMajorRequestPayload": {
            "description": "Information that should be available when you update a major",
            "type": "object",
            "required": [
                "abbreviation",
                "name"
            ],
            "properties": {
                "abbreviation": {
                    "description": "Major Name Abbreviation",
                    "type": "string"
                },
                "facabbr": {
                    "description": "Major Faculty Abbreviation",
                    "type": "string"
                },
                "faculty_id": {
                    "description": "Faculty Id, will be set by the server",
                    "type": "string"
                },
                "name": {
                    "description": "Major Name",
                    "type": "string"
                },
                "updateMajorToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                }
            }
        },
        "material.Content": {
            "type": "object",
            "properties": {
                "id": {
                    "type": "string"
                },
                "link": {
                    "type": "string"
                },
                "material_id": {
                    "type": "string"
                },
                "type": {
                    "$ref": "#/definitions/material.MaterialType"
                }
            }
        },
        "material.CreateMaterialRequest": {
            "type": "object",
            "required": [
                "name",
                "week"
            ],
            "properties": {
                "name": {
                    "type": "string"
                },
                "week": {
                    "type": "integer"
                }
            }
        },
        "material.CreateMaterialResponse": {
            "type": "object",
            "properties": {
                "material_id": {
                    "type": "string"
                }
            }
        },
        "material.Material": {
            "type": "object",
            "properties": {
                "contents": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/material.Content"
                    }
                },
                "course_id": {
                    "type": "string"
                },
                "creator_email": {
                    "type": "string"
                },
                "id": {
                    "type": "string"
                },
                "name": {
                    "type": "string"
                },
                "week": {
                    "type": "integer"
                }
            }
        },
        "material.MaterialType": {
            "type": "integer",
            "enum": [
                1,
                2,
                3
            ],
            "x-enum-varnames": [
                "Handout",
                "Video",
                "External"
            ]
        },
        "material.NewContentRequest": {
            "type": "object",
            "required": [
                "type"
            ],
            "properties": {
                "link": {
                    "type": "string"
                },
                "type": {
                    "$ref": "#/definitions/material.MaterialType"
                }
            }
        },
        "material.NewContentResponse": {
            "type": "object",
            "properties": {
                "upload_link": {
                    "type": "string"
                }
            }
        },
        "materials.AddLessonMaterialsRequestPayload": {
            "description": "Information that should be available when you add a lesson material",
            "type": "object",
            "required": [
                "contents",
                "lesson_id",
                "order"
            ],
            "properties": {
                "addLessonMaterialsToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "contents": {
                    "description": "Lesson Contents",
                    "type": "string"
                },
                "lesson_id": {
                    "description": "Lesson ID",
                    "type": "string"
                },
                "material_id": {
                    "description": "Lesson Material ID, optional",
                    "type": "string"
                },
                "order": {
                    "description": "Lesson Material Order",
                    "type": "integer"
                }
            }
        },
        "materials.UpdateLessonMaterialsRequestPayload": {
            "description": "Information that should be available when you update a lesson material",
            "type": "object",
            "required": [
                "contents",
                "lesson_id",
                "order"
            ],
            "properties": {
                "contents": {
                    "description": "Lesson Contents",
                    "type": "string"
                },
                "lesson_id": {
                    "description": "Lesson ID",
                    "type": "string"
                },
                "material_id": {
                    "description": "Lesson Material ID, optional",
                    "type": "string"
                },
                "order": {
                    "description": "Lesson Material Order",
                    "type": "integer"
                },
                "updateLessonMaterialsToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                }
            }
        },
        "quiz.AddQuizRequestPayload": {
            "description": "Information that should be available when you add a quiz",
            "type": "object",
            "required": [
                "course_id",
                "name"
            ],
            "properties": {
                "addQuizToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                },
                "course_id": {
                    "description": "Course ID",
                    "type": "string"
                },
                "name": {
                    "description": "Quiz Name",
                    "type": "string"
                }
            }
        },
        "quiz.AnswerOption": {
            "type": "object",
            "properties": {
                "answer": {
                    "type": "string"
                },
                "id": {
                    "type": "string"
                },
                "is_solution": {
                    "type": "boolean"
                },
                "media_id": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "quiz.FinishQuizPayload": {
            "type": "object",
            "properties": {
                "data": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/quiz.Response"
                    }
                }
            }
        },
        "quiz.Quiz": {
            "type": "object",
            "properties": {
                "course_id": {
                    "type": "string"
                },
                "creator_email": {
                    "type": "string"
                },
                "id": {
                    "type": "string"
                },
                "nama": {
                    "type": "string"
                }
            }
        },
        "quiz.QuizDetail": {
            "type": "object",
            "properties": {
                "course_id": {
                    "type": "string"
                },
                "description": {
                    "type": "string"
                },
                "help": {
                    "type": "string"
                },
                "id": {
                    "type": "string"
                },
                "media": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/quiz.QuizMedia"
                    }
                },
                "name": {
                    "type": "string"
                },
                "problems": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/quiz.QuizProblem"
                    }
                }
            }
        },
        "quiz.QuizMedia": {
            "type": "object",
            "properties": {
                "id": {
                    "type": "string"
                },
                "type": {
                    "type": "string"
                },
                "url": {
                    "type": "string"
                }
            }
        },
        "quiz.QuizProblem": {
            "type": "object",
            "properties": {
                "answers": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/quiz.AnswerOption"
                    }
                },
                "id": {
                    "type": "string"
                },
                "media_id": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "question": {
                    "type": "string"
                }
            }
        },
        "quiz.Response": {
            "type": "object",
            "properties": {
                "answer_id": {
                    "type": "string"
                },
                "problem_id": {
                    "type": "string"
                }
            }
        },
        "quiz.UpdateQuizRequestPayload": {
            "description": "Information that should be available when you update a quiz",
            "type": "object",
            "properties": {
                "id": {
                    "description": "Quiz ID, Set by param",
                    "type": "string"
                },
                "updateQuizToken": {
                    "description": "Web Token that was appended to the link",
                    "type": "string"
                }
            }
        },
        "refresh.RefreshResponsePayload": {
            "description": "Refresh endpoint response when process success",
            "type": "object",
            "properties": {
                "access_token": {
                    "description": "Token that used to access the resources",
                    "type": "string"
                }
            }
        },
        "register.RegisterRequestPayload": {
            "description": "Information that should be available when do a registration process",
            "type": "object",
            "required": [
                "email",
                "name",
                "password",
                "password_validation"
            ],
            "properties": {
                "email": {
                    "description": "User Email",
                    "type": "string",
                    "example": "someone@example.com"
                },
                "name": {
                    "description": "User name",
                    "type": "string",
                    "example": "someone"
                },
                "password": {
                    "description": "User Password",
                    "type": "string",
                    "example": "secret"
                },
                "password_validation": {
                    "description": "User Password Validation, must be same as user",
                    "type": "string",
                    "example": "secret"
                }
            }
        },
        "request.RequestRequestPayload": {
            "description": "Information that should be available when password reset is requested",
            "type": "object",
            "required": [
                "email"
            ],
            "properties": {
                "email": {
                    "description": "User Email",
                    "type": "string",
                    "example": "someone@example.com"
                }
            }
        },
        "verification.VerificationRequestPayload": {
            "type": "object",
            "required": [
                "id"
            ],
            "properties": {
                "id": {
                    "type": "string",
                    "example": "6ba7b812-9dad-11d1-80b4-00c04fd430c8"
                }
            }
        },
        "verification.VerificationSendRequestPayload": {
            "description": "Information that should be passed when request verify",
            "type": "object",
            "required": [
                "email"
            ],
            "properties": {
                "email": {
                    "description": "User Email",
                    "type": "string",
                    "example": "someone@example.com"
                }
            }
        },
        "web.BaseResponse": {
            "type": "object",
            "properties": {
                "data": {},
                "message": {
                    "type": "string"
                },
                "status": {
                    "type": "string",
                    "enum": [
                        "success",
                        "failed"
                    ]
                }
            }
        }
    }
}`

// SwaggerInfo holds exported Swagger Info so clients can modify it
var SwaggerInfo = &swag.Spec{
	Version:          "1.0.1",
	Host:             "",
	BasePath:         "",
	Schemes:          []string{},
	Title:            "Open Courseware Application",
	Description:      "This is Open Couseware backend",
	InfoInstanceName: "swagger",
	SwaggerTemplate:  docTemplate,
}

func init() {
	swag.Register(SwaggerInfo.InstanceName(), SwaggerInfo)
}
